diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/qos-txop.cc ns-3.31/src/wifi/model/qos-txop.cc
--- ns-3.30.1/src/wifi/model/qos-txop.cc	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/wifi/model/qos-txop.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,6 +38,8 @@
 #include "mpdu-aggregator.h"
 #include "ctrl-headers.h"
 #include "wifi-phy.h"
+#include "wifi-ack-policy-selector.h"
+#include "wifi-psdu.h"
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT if (m_low != 0) { std::clog << "[mac=" << m_low->GetAddress () << "] "; }
@@ -55,13 +57,13 @@
     .SetParent<ns3::Txop> ()
     .SetGroupName ("Wifi")
     .AddConstructor<QosTxop> ()
-    .AddAttribute ("UseExpliciteBarAfterMissedBlockAck",
-                   "Specify whether explicit Block Ack Request should be sent upon missed Block Ack Response.",
+    .AddAttribute ("UseExplicitBarAfterMissedBlockAck",
+                   "Specify whether explicit BlockAckRequest should be sent upon missed BlockAck Response.",
                    BooleanValue (true),
                    MakeBooleanAccessor (&QosTxop::m_useExplicitBarAfterMissedBlockAck),
                    MakeBooleanChecker ())
     .AddAttribute ("AddBaResponseTimeout",
-                   "The timeout to wait for ADDBA response after the ACK to "
+                   "The timeout to wait for ADDBA response after the Ack to "
                    "ADDBA request is received.",
                    TimeValue (MilliSeconds (1)),
                    MakeTimeAccessor (&QosTxop::SetAddBaResponseTimeout,
@@ -82,7 +84,7 @@
                    MakePointerAccessor (&QosTxop::m_baManager),
                    MakePointerChecker<BlockAckManager> ())
     .AddTraceSource ("TxopTrace",
-                     "Trace source for txop start and duration times",
+                     "Trace source for TXOP start and duration times",
                      MakeTraceSourceAccessor (&QosTxop::m_txopTrace),
                      "ns3::TracedValueCallback::Time")
   ;
@@ -116,6 +118,7 @@
 QosTxop::DoDispose (void)
 {
   NS_LOG_FUNCTION (this);
+  m_ackPolicySelector = 0;
   m_baManager = 0;
   m_qosBlockedDestinations = 0;
   Txop::DoDispose ();
@@ -139,6 +142,33 @@
   return m_baManager->GetOriginatorStartingSequence (address, tid);
 }
 
+Ptr<const WifiMacQueueItem>
+QosTxop::PrepareBlockAckRequest (Mac48Address recipient, uint8_t tid) const
+{
+  NS_LOG_FUNCTION (this << recipient << +tid);
+
+  CtrlBAckRequestHeader reqHdr = m_low->GetEdca (tid)->m_baManager->GetBlockAckReqHeader (recipient, tid);
+  Ptr<Packet> bar = Create<Packet> ();
+  bar->AddHeader (reqHdr);
+
+  WifiMacHeader hdr;
+  hdr.SetType (WIFI_MAC_CTL_BACKREQ);
+  hdr.SetAddr1 (recipient);
+  hdr.SetAddr2 (m_low->GetAddress ());
+  hdr.SetDsNotTo ();
+  hdr.SetDsNotFrom ();
+  hdr.SetNoRetry ();
+  hdr.SetNoMoreFragments ();
+
+  return Create<const WifiMacQueueItem> (bar, hdr);
+}
+
+void
+QosTxop::ScheduleBar (Ptr<const WifiMacQueueItem> bar, bool skipIfNoDataQueued)
+{
+  m_baManager->ScheduleBar (bar, skipIfNoDataQueued);
+}
+
 void
 QosTxop::SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager)
 {
@@ -148,6 +178,19 @@
 }
 
 void
+QosTxop::SetAckPolicySelector (Ptr<WifiAckPolicySelector> ackSelector)
+{
+  NS_LOG_FUNCTION (this << ackSelector);
+  m_ackPolicySelector = ackSelector;
+}
+
+Ptr<WifiAckPolicySelector>
+QosTxop::GetAckPolicySelector (void) const
+{
+  return m_ackPolicySelector;
+}
+
+void
 QosTxop::SetTypeOfStation (TypeOfStation type)
 {
   NS_LOG_FUNCTION (this << +type);
@@ -160,6 +203,14 @@
   return m_typeOfStation;
 }
 
+bool
+QosTxop::HasFramesToTransmit (void)
+{
+  bool ret = (m_currentPacket != 0 || m_baManager->HasPackets () || !m_queue->IsEmpty ());
+  NS_LOG_FUNCTION (this << ret);
+  return ret;
+}
+
 uint16_t
 QosTxop::GetNextSequenceNumberFor (const WifiMacHeader *hdr)
 {
@@ -283,7 +334,7 @@
   Ptr<const WifiMacQueueItem> testItem;
   WifiMacQueue::ConstIterator testIt;
 
-  // the packet can only have been peeked from the Block Ack manager retransmit
+  // the packet can only have been peeked from the block ack manager retransmit
   // queue if:
   // - the peeked packet is a QoS Data frame AND
   // - the peeked packet is not a broadcast frame AND
@@ -308,9 +359,7 @@
         }
     }
 
-  // the packet has been peeked from the EDCA queue.
-  uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor (&peekedItem->GetHeader ());
-
+  // The packet has been peeked from the EDCA queue.
   // If it is a QoS Data frame and it is not a broadcast frame, attempt A-MSDU
   // aggregation if aggregate is true
   if (peekedItem->GetHeader ().IsQosData ())
@@ -320,6 +369,8 @@
 
       NS_ASSERT (testIt != m_queue->end () && (*testIt)->GetPacket () == peekedItem->GetPacket ());
 
+      uint16_t sequence = m_txMiddle->PeekNextSequenceNumberFor (&peekedItem->GetHeader ());
+
       // check if the peeked packet is within the transmit window
       if (GetBaAgreementEstablished (recipient, tid)
           && !IsInWindow (sequence, GetBaStartingSequence (recipient, tid), GetBaBufferSize (recipient, tid)))
@@ -351,8 +402,10 @@
       NS_ASSERT (item != 0 && item->GetPacket () == peekedItem->GetPacket ());
     }
 
-  // Assign a sequence number to the MSDU or A-MSDU dequeued from the EDCA queue
   NS_ASSERT (item != 0);
+
+  // Assign a sequence number to the MSDU or A-MSDU dequeued from the EDCA queue
+  uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor (&item->GetHeader ());
   item->GetHeader ().SetSequenceNumber (sequence);
   item->GetHeader ().SetFragmentNumber (0);
   item->GetHeader ().SetNoMoreFragments ();
@@ -388,8 +441,7 @@
 
   // Enable/disable RTS
   if (!frame->GetHeader ().IsBlockAckReq ()
-      && m_stationManager->NeedRts (recipient, &frame->GetHeader (),
-                                    frame->GetPacket (), m_low->GetDataTxVector (frame))
+      && m_stationManager->NeedRts (frame->GetHeader (), frame->GetSize ())
       && !m_low->IsCfPeriod ())
     {
       params.EnableRts ();
@@ -399,52 +451,33 @@
       params.DisableRts ();
     }
 
-  uint8_t tid;
-  CtrlBAckRequestHeader baReqHdr;
-  if (frame->GetHeader ().IsBlockAckReq ())
-    {
-      frame->GetPacket ()->PeekHeader (baReqHdr);
-      tid = baReqHdr.GetTidInfo ();
-    }
-  else if (frame->GetHeader ().IsQosData ())
-    {
-      tid = frame->GetHeader ().GetQosTid ();
-    }
-  else
-    {
-      NS_ABORT_MSG ("Unexpected type of frame");
-    }
-
   // Select ack technique.
-  if (frame->GetHeader ().IsQosData () && !GetBaAgreementEstablished (recipient, tid))
+  if (frame->GetHeader ().IsQosData ())
     {
-      // normal ack in case of QoS data frame with no agreement established
-      // TODO We should also arrive here in case of block ack request with delayed
-      // block ack, which is currently unsupported
+      // Assume normal Ack by default
       params.EnableAck ();
     }
-  else if (frame->GetHeader ().IsQosData () && frame->GetHeader ().IsQosBlockAck ())
-    {
-      // no ack after a QoS data frame with explicit block ack policy
-      params.DisableAck ();
-    }
-  else
+  else if (frame->GetHeader ().IsBlockAckReq ())
     {
-      // assume a block ack variant. Later, if this frame is not aggregated,
-      // the acknowledgment type will be switched to normal ack
+      // assume a BlockAck variant. Later, if this frame is not aggregated,
+      // the acknowledgment type will be switched to normal Ack
       if (m_blockAckType == BASIC_BLOCK_ACK)
         {
-          params.EnableBasicBlockAck ();
+          params.EnableBlockAck (BlockAckType::BASIC_BLOCK_ACK);
         }
       else if (m_blockAckType == COMPRESSED_BLOCK_ACK)
         {
+          CtrlBAckRequestHeader baReqHdr;
+          frame->GetPacket ()->PeekHeader (baReqHdr);
+          uint8_t tid = baReqHdr.GetTidInfo ();
+
           if (GetBaBufferSize (recipient, tid) > 64)
             {
-              params.EnableExtendedCompressedBlockAck ();
+              params.EnableBlockAck (BlockAckType::EXTENDED_COMPRESSED_BLOCK_ACK);
             }
           else
             {
-              params.EnableCompressedBlockAck ();
+              params.EnableBlockAck (BlockAckType::COMPRESSED_BLOCK_ACK);
             }
         }
       else if (m_blockAckType == MULTI_TID_BLOCK_ACK)
@@ -457,6 +490,15 @@
 }
 
 void
+QosTxop::UpdateCurrentPacket (Ptr<WifiMacQueueItem> mpdu)
+{
+  NS_LOG_FUNCTION (this << *mpdu);
+  m_currentPacket = mpdu->GetPacket ();
+  m_currentHdr = mpdu->GetHeader ();
+  m_currentPacketTimestamp = mpdu->GetTimeStamp ();
+}
+
+void
 QosTxop::NotifyAccessGranted (void)
 {
   NS_LOG_FUNCTION (this);
@@ -471,127 +513,124 @@
       NS_LOG_DEBUG ("the lifetime of current packet expired");
       m_currentPacket = 0;
     }
+  // If the current packet is a QoS Data frame, then there must be no block ack agreement
+  // established with the receiver for the TID of the packet. Indeed, retransmission
+  // of MPDUs sent under a block ack agreement is handled through the retransmit queue.
+  NS_ASSERT (m_currentPacket == 0 || !m_currentHdr.IsQosData ()
+             || !GetBaAgreementEstablished (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ()));
+
   if (m_currentPacket == 0)
     {
-      if (m_baManager->HasBar (m_currentBar))
+      Ptr<const WifiMacQueueItem> peekedItem = m_baManager->GetBar ();
+      if (peekedItem != 0)
         {
-          SendBlockAckRequest (m_currentBar);
-          return;
+          m_currentHdr = peekedItem->GetHeader ();
+          m_currentPacket = peekedItem->GetPacket ();
+          m_currentPacketTimestamp = Simulator::Now ();
         }
-      Ptr<const WifiMacQueueItem> peekedItem = PeekNextFrame ();
-      if (peekedItem == 0)
-        {
-          NS_LOG_DEBUG ("no packets available for transmission");
-          return;
-        }
-      // check if a Block Ack agreement needs to be established
-      m_currentHdr = peekedItem->GetHeader ();
-      m_currentPacket = peekedItem->GetPacket ();
-      if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsBroadcast ()
-          && m_stationManager->GetQosSupported (m_currentHdr.GetAddr1 ())
-          && (!m_baManager->ExistsAgreement (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ())
-              || m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid (), OriginatorBlockAckAgreement::RESET))
-          && SetupBlockAckIfNeeded ())
+      else
         {
-          return;
-        }
+          peekedItem = PeekNextFrame ();
+          if (peekedItem == 0)
+            {
+              NS_LOG_DEBUG ("no packets available for transmission");
+              return;
+            }
+          // check if a block ack agreement needs to be established
+          m_currentHdr = peekedItem->GetHeader ();
+          m_currentPacket = peekedItem->GetPacket ();
+          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsBroadcast ()
+              && m_stationManager->GetQosSupported (m_currentHdr.GetAddr1 ())
+              && (!m_baManager->ExistsAgreement (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ())
+                  || m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid (), OriginatorBlockAckAgreement::RESET))
+              && SetupBlockAckIfNeeded ())
+            {
+              return;
+            }
 
-      m_stationManager->UpdateFragmentationThreshold ();
-      Time ppduDurationLimit = Seconds (0);
+          m_stationManager->UpdateFragmentationThreshold ();
+          Ptr<WifiMacQueueItem> item;
+          // non-broadcast QoS Data frames may be sent in MU PPDUs. Given that at this stage
+          // we do not know the bandwidth it would be given nor the selected acknowledgment
+          // sequence, we cannot determine the constraints on size and duration limit. Hence,
+          // we only peek the non-broadcast QoS Data frame. MacLow will be in charge of
+          // computing the correct limits and dequeue the frame.
+          if (peekedItem->GetHeader ().IsQosData () && !peekedItem->GetHeader ().GetAddr1 ().IsBroadcast ()
+              && !NeedFragmentation ())
+            {
+              item = Copy (peekedItem);
+            }
+          else
+            {
+              // compute the limit on the PPDU duration due to the TXOP duration, if any
+              Time ppduDurationLimit = Time::Min ();
+              if (peekedItem->GetHeader ().IsQosData () && GetTxopLimit ().IsStrictlyPositive ())
+                {
+                  MacLowTransmissionParameters params = GetTransmissionParameters (peekedItem);
+                  ppduDurationLimit = GetTxopRemaining () - m_low->CalculateOverheadTxTime (peekedItem, params);
+                }
 
-      // compute the limit on the PPDU duration due to the TXOP duration, if any
-      if (peekedItem->GetHeader ().IsQosData () && GetTxopLimit ().IsStrictlyPositive ())
-        {
-          MacLowTransmissionParameters params = GetTransmissionParameters (peekedItem);
-          ppduDurationLimit = GetTxopRemaining () - m_low->CalculateOverheadTxTime (peekedItem, params);
-        }
+                // dequeue the peeked item if it fits within the TXOP duration, if any
+                item = DequeuePeekedFrame (peekedItem, m_low->GetDataTxVector (peekedItem),
+                                          !NeedFragmentation (), 0, ppduDurationLimit);
+            }
 
-      // dequeue the peeked item if it fits within the TXOP duration, if any
-      Ptr<WifiMacQueueItem> item = DequeuePeekedFrame (peekedItem, m_low->GetDataTxVector (peekedItem),
-                                                       !NeedFragmentation (), 0, ppduDurationLimit);
+          if (item == 0)
+            {
+              NS_LOG_DEBUG ("Not enough time in the current TXOP");
+              return;
+            }
+          m_currentPacket = item->GetPacket ();
+          m_currentHdr = item->GetHeader ();
+          m_currentPacketTimestamp = item->GetTimeStamp ();
 
-      if (item == 0)
-        {
-          NS_LOG_DEBUG ("Not enough time in the current TXOP");
-          return;
+          m_fragmentNumber = 0;
         }
-      m_currentPacket = item->GetPacket ();
-      m_currentHdr = item->GetHeader ();
-      m_currentPacketTimestamp = item->GetTimeStamp ();
       NS_ASSERT (m_currentPacket != 0);
-
-      m_fragmentNumber = 0;
-      if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsBroadcast ())
-        {
-          VerifyBlockAck ();
-        }
     }
   Ptr<WifiMacQueueItem> mpdu = Create <WifiMacQueueItem> (m_currentPacket, m_currentHdr,
                                                           m_currentPacketTimestamp);
+  m_currentParams = GetTransmissionParameters (mpdu);
+
   if (m_currentHdr.GetAddr1 ().IsGroup ())
     {
-      m_currentParams.DisableRts ();
-      m_currentParams.DisableAck ();
-      m_currentParams.DisableNextData ();
       NS_LOG_DEBUG ("tx broadcast");
       m_low->StartTransmission (mpdu, m_currentParams, this);
     }
-  else if (m_currentHdr.GetType () == WIFI_MAC_CTL_BACKREQ)
-    {
-      SendBlockAckRequest (m_currentBar);
-    }
-  else
+  //With COMPRESSED_BLOCK_ACK fragmentation must be avoided.
+  else if (((m_currentHdr.IsQosData () && !m_currentHdr.IsQosAmsdu ())
+            || (m_currentHdr.IsData () && !m_currentHdr.IsQosData ()))
+           && (GetBlockAckThreshold () == 0 || m_blockAckType == BASIC_BLOCK_ACK)
+           && NeedFragmentation ())
     {
-      m_currentParams = GetTransmissionParameters (mpdu);
-
-      // check if the current frame meets the QoS TXOP Limit, if any
-      if (mpdu->GetHeader ().IsQosData () && GetTxopLimit ().IsStrictlyPositive () &&
-          m_low->CalculateOverallTxTime (mpdu->GetPacket (), &mpdu->GetHeader (),
-                                         m_currentParams) > GetTxopRemaining ())
+      m_currentIsFragmented = true;
+      m_currentParams.DisableRts ();
+      WifiMacHeader hdr;
+      Ptr<Packet> fragment = GetFragmentPacket (&hdr);
+      if (IsLastFragment ())
         {
-          NS_LOG_DEBUG ("Not enough time in the current TXOP");
-          return;
-        }
-
-      //With COMPRESSED_BLOCK_ACK fragmentation must be avoided.
-      if (((m_currentHdr.IsQosData () && !m_currentHdr.IsQosAmsdu ())
-           || (m_currentHdr.IsData () && !m_currentHdr.IsQosData ()))
-          && (GetBlockAckThreshold () == 0 || m_blockAckType == BASIC_BLOCK_ACK)
-          && NeedFragmentation ())
-        {
-          m_currentIsFragmented = true;
-          m_currentParams.DisableRts ();
-          WifiMacHeader hdr;
-          Ptr<Packet> fragment = GetFragmentPacket (&hdr);
-          if (IsLastFragment ())
-            {
-              NS_LOG_DEBUG ("fragmenting last fragment size=" << fragment->GetSize ());
-              m_currentParams.DisableNextData ();
-            }
-          else
-            {
-              NS_LOG_DEBUG ("fragmenting size=" << fragment->GetSize ());
-              m_currentParams.EnableNextData (GetNextFragmentSize ());
-            }
-          m_low->StartTransmission (Create<WifiMacQueueItem> (fragment, hdr),
-                                    m_currentParams, this);
+          NS_LOG_DEBUG ("fragmenting last fragment size=" << fragment->GetSize ());
+          m_currentParams.DisableNextData ();
         }
       else
         {
-          m_currentIsFragmented = false;
-          m_low->StartTransmission (mpdu, m_currentParams, this);
-          if (!GetAmpduExist (m_currentHdr.GetAddr1 ()))
-            {
-              CompleteTx ();
-            }
+          NS_LOG_DEBUG ("fragmenting size=" << fragment->GetSize ());
+          m_currentParams.EnableNextData (GetNextFragmentSize ());
         }
+      m_low->StartTransmission (Create<WifiMacQueueItem> (fragment, hdr),
+                                m_currentParams, this);
+    }
+  else
+    {
+      m_currentIsFragmented = false;
+      m_low->StartTransmission (mpdu, m_currentParams, this);
     }
 }
 
 void QosTxop::NotifyInternalCollision (void)
 {
   NS_LOG_FUNCTION (this);
-  bool resetDcf = false;
+  bool resetTxop = false;
   // If an internal collision is experienced, the frame involved may still
   // be sitting in the queue, and m_currentPacket may still be null.
   Ptr<const Packet> packet;
@@ -616,7 +655,7 @@
         {
           if (!NeedRtsRetransmission (packet, header))
             {
-              resetDcf = true;
+              resetTxop = true;
               m_stationManager->ReportFinalRtsFailed (header.GetAddr1 (), &header);
             }
           else
@@ -626,13 +665,13 @@
         }
       else if (header.GetAddr1 () == Mac48Address::GetBroadcast ())
         {
-          resetDcf = false;
+          resetTxop = false;
         }
       else
         {
           if (!NeedDataRetransmission (packet, header))
             {
-              resetDcf = true;
+              resetTxop = true;
               m_stationManager->ReportFinalDataFailed (header.GetAddr1 (), &header, packet->GetSize ());
             }
           else
@@ -640,14 +679,14 @@
               m_stationManager->ReportDataFailed (header.GetAddr1 (), &header, packet->GetSize ());
             }
         }
-      if (resetDcf)
+      if (resetTxop)
         {
           NS_LOG_DEBUG ("reset DCF");
           if (!m_txFailedCallback.IsNull ())
             {
               m_txFailedCallback (header);
             }
-          //to reset the dcf.
+          //to reset the Txop.
           if (m_currentPacket)
             {
               NS_LOG_DEBUG ("Discarding m_currentPacket");
@@ -665,19 +704,7 @@
           UpdateFailedCw ();
         }
     }
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
-  RestartAccessIfNeeded ();
-}
-
-void
-QosTxop::NotifyCollision (void)
-{
-  NS_LOG_FUNCTION (this);
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -699,7 +726,7 @@
         {
           m_baManager->NotifyDiscardedMpdu (mpdu);
         }
-      //to reset the dcf.
+      //to reset the Txop.
       m_currentPacket = 0;
       ResetCw ();
       m_cwTrace = GetCw ();
@@ -723,9 +750,7 @@
           m_currentPacket = 0;
         }
     }
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -765,7 +790,7 @@
                 }
               else if (actionHdr.GetAction ().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST)
                 {
-                  // Setup addba response timeout
+                  // Setup ADDBA response timeout
                   MgtAddBaRequestHeader addBa;
                   p->PeekHeader (addBa);
                   Simulator::Schedule (m_addBaResponseTimeout,
@@ -843,9 +868,7 @@
       UpdateFailedCw ();
       m_cwTrace = GetCw ();
     }
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -859,10 +882,6 @@
    * frames. (IEEE std 802.11-2016 sec. 10.24.7.7
    */
   uint8_t tid = GetTid (m_currentPacket, m_currentHdr);
-  if (GetAmpduExist (m_currentHdr.GetAddr1 ()))
-    {
-      m_stationManager->ReportAmpduTxStatus (m_currentHdr.GetAddr1 (), tid, 0, nMpdus, 0, 0);
-    }
   if (m_useExplicitBarAfterMissedBlockAck || m_currentHdr.IsBlockAckReq ())
     {
       if (NeedBarRetransmission ())
@@ -874,17 +893,40 @@
               UpdateFailedCw ();
               m_cwTrace = GetCw ();
             }
-          else // missed block ack after data frame with Implicit BAR Ack policy
+          else // missed BlockAck after data frame with Implicit BAR Ack Policy
             {
-              m_baManager->ScheduleBlockAckReq (m_currentHdr.GetAddr1 (), tid);
+              Ptr<const WifiMacQueueItem> bar = PrepareBlockAckRequest (m_currentHdr.GetAddr1 (), tid);
+              ScheduleBar (bar);
               m_currentPacket = 0;
             }
         }
       else
         {
           NS_LOG_DEBUG ("Block Ack Request Fail");
-          //to reset the dcf.
-          m_baManager->DiscardOutstandingMpdus (m_currentHdr.GetAddr1 (), GetTid (m_currentPacket, m_currentHdr));
+          // if a BA agreement exists, we can get here if there is no outstanding
+          // MPDU whose lifetime has not expired yet.
+          m_stationManager->ReportFinalDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr,
+                                                   m_currentPacket->GetSize ());
+          if (m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), tid,
+                                                   OriginatorBlockAckAgreement::ESTABLISHED))
+            {
+              // If there is any (expired) outstanding MPDU, request the BA manager to discard
+              // it, which involves the scheduling of a BAR to advance the recipient's window
+              if (m_baManager->GetNBufferedPackets (m_currentHdr.GetAddr1 (), tid) > 0)
+                {
+                  m_baManager->DiscardOutstandingMpdus (m_currentHdr.GetAddr1 (), tid);
+                }
+              // otherwise, it means that we have not received a BlockAck in response to a
+              // BlockAckRequest sent while no frame was outstanding, whose purpose was therefore
+              // to advance the recipient's window. Schedule a BlockAckRequest with
+              // skipIfNoDataQueued set to true, so that the BlockAckRequest is only sent
+              // if there are data frames queued for this recipient.
+              else
+                {
+                  ScheduleBar (PrepareBlockAckRequest (m_currentHdr.GetAddr1 (), tid), true);
+                }
+            }
+          //to reset the Txop.
           m_currentPacket = 0;
           ResetCw ();
           m_cwTrace = GetCw ();
@@ -892,10 +934,16 @@
     }
   else
     {
-      // implicit BAR and do not use BAR after missed block ack, hence try to retransmit data frames
+      if (GetAmpduExist (m_currentHdr.GetAddr1 ()))
+        {
+          m_stationManager->ReportAmpduTxStatus (m_currentHdr.GetAddr1 (), 0, nMpdus, 0, 0, WifiTxVector ());
+        }
+      // implicit BAR and do not use BAR after missed BlockAck, hence try to retransmit data frames
       if (!NeedDataRetransmission (m_currentPacket, m_currentHdr))
         {
           NS_LOG_DEBUG ("Block Ack Fail");
+          m_stationManager->ReportFinalDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr,
+                                                   m_currentPacket->GetSize ());
           if (!m_txFailedCallback.IsNull ())
             {
               m_txFailedCallback (m_currentHdr);
@@ -915,7 +963,7 @@
                     }
                 }
             }
-          //to reset the dcf.
+          //to reset the Txop.
           m_baManager->DiscardOutstandingMpdus (m_currentHdr.GetAddr1 (), GetTid (m_currentPacket, m_currentHdr));
           m_currentPacket = 0;
           ResetCw ();
@@ -924,15 +972,14 @@
       else
         {
           NS_LOG_DEBUG ("Retransmit");
+          m_stationManager->ReportDataFailed (m_currentHdr.GetAddr1 (), &m_currentHdr, m_currentPacket->GetSize ());
           m_baManager->NotifyMissedBlockAck (m_currentHdr.GetAddr1 (), tid);
           m_currentPacket = 0;
           UpdateFailedCw ();
           m_cwTrace = GetCw ();
         }
     }
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -940,33 +987,29 @@
 QosTxop::RestartAccessIfNeeded (void)
 {
   NS_LOG_FUNCTION (this);
-  if ((m_currentPacket != 0
-       // check first if the BA manager retransmit queue is empty, so that expired
-       // frames (if any) are removed and a Block Ack Request is scheduled to advance
-       // the starting sequence number of the transmit (and receiver) window
-       || m_baManager->HasPackets () || !m_queue->IsEmpty ())
+
+  // check if the BA manager retransmit queue is empty, so that expired
+  // frames (if any) are removed and a BlockAckRequest is scheduled to advance
+  // the starting sequence number of the transmit (and receiver) window
+  bool baManagerHasPackets = m_baManager->HasPackets ();
+  // remove MSDUs with expired lifetime starting from the head of the queue
+  bool queueIsNotEmpty = !m_queue->IsEmpty ();
+
+  if ((m_currentPacket != 0 || baManagerHasPackets || queueIsNotEmpty)
       && !IsAccessRequested ())
     {
-      Ptr<const Packet> packet;
-      WifiMacHeader hdr;
+      Ptr<const WifiMacQueueItem> item;
       if (m_currentPacket != 0)
         {
-          packet = m_currentPacket;
-          hdr = m_currentHdr;
+          item = Create<const WifiMacQueueItem> (m_currentPacket, m_currentHdr);
         }
       else
         {
-          Ptr<const WifiMacQueueItem> item = PeekNextFrame ();
-          if (item)
-            {
-              packet = item->GetPacket ();
-              hdr = item->GetHeader ();
-            }
+          item = PeekNextFrame ();
         }
-      if (packet != 0)
+      if (item != 0)
         {
-          m_isAccessRequestedForRts = m_stationManager->NeedRts (hdr.GetAddr1 (), &hdr, packet,
-                                                                 m_low->GetDataTxVector (Create<const WifiMacQueueItem> (packet, hdr)));
+          m_isAccessRequestedForRts = m_stationManager->NeedRts (item->GetHeader (), item->GetSize ());
         }
       else
         {
@@ -980,25 +1023,22 @@
 QosTxop::StartAccessIfNeeded (void)
 {
   NS_LOG_FUNCTION (this);
+
+  // check if the BA manager retransmit queue is empty, so that expired
+  // frames (if any) are removed and a BlockAckRequest is scheduled to advance
+  // the starting sequence number of the transmit (and receiver) window
+  bool baManagerHasPackets = m_baManager->HasPackets ();
+  // remove MSDUs with expired lifetime starting from the head of the queue
+  bool queueIsNotEmpty = !m_queue->IsEmpty ();
+
   if (m_currentPacket == 0
-      // check first if the BA manager retransmit queue is empty, so that expired
-      // frames (if any) are removed and a Block Ack Request is scheduled to advance
-      // the starting sequence number of the transmit (and receiver) window
-      && (m_baManager->HasPackets () || !m_queue->IsEmpty ())
+      && (baManagerHasPackets || queueIsNotEmpty)
       && !IsAccessRequested ())
     {
-      Ptr<const Packet> packet;
-      WifiMacHeader hdr;
       Ptr<const WifiMacQueueItem> item = PeekNextFrame ();
-      if (item)
-        {
-          packet = item->GetPacket ();
-          hdr = item->GetHeader ();
-        }
-      if (packet != 0)
+      if (item != 0)
         {
-          m_isAccessRequestedForRts = m_stationManager->NeedRts (hdr.GetAddr1 (), &hdr, packet,
-                                                                 m_low->GetDataTxVector (Create<const WifiMacQueueItem> (packet, hdr)));
+          m_isAccessRequestedForRts = m_stationManager->NeedRts (item->GetHeader (), item->GetSize ());
         }
       else
         {
@@ -1012,27 +1052,23 @@
 QosTxop::NeedBarRetransmission (void)
 {
   uint8_t tid = 0;
-  uint16_t seqNumber = 0;
   if (m_currentHdr.IsQosData ())
     {
       tid = m_currentHdr.GetQosTid ();
-      seqNumber = m_currentHdr.GetSequenceNumber ();
     }
   else if (m_currentHdr.IsBlockAckReq ())
     {
       CtrlBAckRequestHeader baReqHdr;
       m_currentPacket->PeekHeader (baReqHdr);
       tid = baReqHdr.GetTidInfo ();
-      seqNumber = baReqHdr.GetStartingSequence ();
     }
   else if (m_currentHdr.IsBlockAck ())
     {
       CtrlBAckResponseHeader baRespHdr;
       m_currentPacket->PeekHeader (baRespHdr);
       tid = baRespHdr.GetTidInfo ();
-      seqNumber = m_currentHdr.GetSequenceNumber ();
     }
-  return m_baManager->NeedBarRetransmission (tid, seqNumber, m_currentHdr.GetAddr1 ());
+  return m_baManager->NeedBarRetransmission (tid, m_currentHdr.GetAddr1 ());
 }
 
 void
@@ -1042,17 +1078,10 @@
   NS_ASSERT (GetTxopLimit ().IsStrictlyPositive () && GetTxopRemaining ().IsStrictlyPositive ());
 
   m_currentPacket = 0;
-  Ptr<const WifiMacQueueItem> nextFrame;
-
   // peek the next BlockAckReq, if any
-  if (m_baManager->HasBar (m_currentBar, false))
-    {
-      WifiMacHeader hdr;
-      hdr.SetType (WIFI_MAC_CTL_BACKREQ);
-      hdr.SetAddr1 (m_currentBar.recipient);
-      nextFrame = Create<const WifiMacQueueItem> (m_currentBar.bar, hdr);
-    }
-  else
+  Ptr<const WifiMacQueueItem> nextFrame = m_baManager->GetBar (false);
+
+  if (nextFrame == 0)
     {
       nextFrame = PeekNextFrame ();
     }
@@ -1063,15 +1092,7 @@
 
       if (GetTxopRemaining () >= m_low->CalculateOverallTxTime (nextFrame->GetPacket (), &nextFrame->GetHeader (), params))
         {
-          if (nextFrame->GetHeader ().IsBlockAckReq ())
-            {
-              NS_LOG_DEBUG ("start next BlockAckReq within the current TXOP");
-              m_baManager->HasBar (m_currentBar);
-              SendBlockAckRequest (m_currentBar);
-              return;
-            }
-
-          // check if a Block Ack agreement needs to be established
+          // check if a block ack agreement needs to be established
           m_currentHdr = nextFrame->GetHeader ();
           m_currentPacket = nextFrame->GetPacket ();
           if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsBroadcast ()
